MODULE GetCDDB;
IMPORT
   (* IF DebugInfo *) D: ggDebug, (* $END *)
   (* $IF NoGuru *) NoGuru2, (* $END *)
   y: SYSTEM, e: Exec, d: Dos, u: Utility, ol: OberonLib, 
   tb: ToolBox, st: Strings, xs: cddbstrings,

   (* mr: MuiRequests, *)
   cddb, bi:= BurnItDriver, biCDDB;

VAR
   lock,
   oldCD	: d.FileLockPtr;

   scsi		: bi.SCSIPtr;

   tr,
   min,sec,frame,
   min2,sec2,frame2,
   secs,
   err,
   ret,
   det 		: LONGINT;
   
   tocDiscID	: bi.TOCDataFormat00;
   
   buffer	: ARRAY 4000 OF CHAR;
   
   cap 		: bi.ReadCDRomCapacityData;

   totSecs 	: LONGINT;

   cdi      	: cddb.CDInfo;

   discID	: LONGINT;
   categ	: ARRAY cddb.maxLenCateg OF CHAR;
   artist	: ARRAY cddb.maxLenArtist OF CHAR;
   dTitle	: ARRAY cddb.maxLenDTitle OF CHAR;
   tTitles	: ARRAY cddb.maxTracks OF UNTRACED POINTER TO ARRAY cddb.maxLenTTitle OF CHAR;
   
   kCD          : cddb.KnownCD;

   CDDBStatusHook: u.HookPtr;  
   
   ErrStr       : e.STRPTR;
   
PROCEDURE ErrorStr * (err{0}: LONGINT; VAR errStrPtr{8+0}: e.STRPTR);
(* $SaveRegs+ *)
BEGIN
     (* $Debug- *) ol.SetA5; (* $Debug= *)
     errStrPtr := xs.Get(xs.errGetCDDB0+err);
     (* If I use RETURN strPtr, then there come muForceHits and nothing is returned, really strange;-( *)

(* $IF DebugInfo *)  D.KPrintf ("ErrorStr: err = %ld, xs.errGetCDDB0 = %ld, xs.errGetCDDB0+err = %ld\n", err, xs.errGetCDDB0, xs.errGetCDDB0+err);
     D.KPrintf ("xs.Get(xs.errGetCDDB0+err) = '%s'\n", xs.Get(xs.errGetCDDB0+err));
(* $END *)
     (* RETURN xs.Get(xs.errGetCDDB0+err) *)
END ErrorStr;

(* $SaveRegs+ $StackChk- $ClearVars- *)
PROCEDURE CDDBStatusFunc (hook: u.HookPtr; nil: e.APTR; msg: cddb.pStatusHookPtr): e.APTR;  (* a0/a2/a1 *)
BEGIN
     (* $Debug- *) ol.SetA5; (* $Debug= *)

     d.PrintF ("**CDDB: %s\n", msg.str); RETURN 0;
END CDDBStatusFunc;
(* $ClearVars+ $StackChk= *)


BEGIN
     IF cddb.base = NIL THEN d.PrintF ("cddb.library not found!\n"); HALT(20) END;
     (* d.PrintF ("SIZE(cddb.base^) = %ld\n", SIZE(cddb.base^)); *)
 
     lock := d.Lock("BI:", d.read); IF lock = NIL THEN d.PrintF ("Dos.Lock(\"BI:\") failed.\n"); HALT(5) END;
     oldCD := d.CurrentDir (lock);

     scsi := bi.InitSCSIUnit ("cybscsi.device", bi.ScsiMsgPortName, 1, 0);
     IF scsi = NIL THEN HALT(5) END;

     det := bi.DetermineUnit (scsi); (*d.PrintF ("det = %ld\n",det);*)
     

     (* discID := biCDDB.CDDBdiscID (scsi, totSecs); *)
     (* d.PrintF ("discID = 0x%08lx calculated with CDDBdiscID(), totSecs = %ld\n", discID, totSecs); *)

     discID := biCDDB.ComputeDiscID (scsi, NIL, y.ADR(cdi), totSecs);
     (* d.PrintF ("discID = 0x%08lx calculated with ComputeDiscID(), totSecs = %ld\n", discID, totSecs); *)
(*
     FOR tr := 0 TO cdi.tracks DO
        d.PrintF ("tr = %ld, msf: min %ld, sec %ld, frame %ld\n", tr, cdi.msf[tr].min, cdi.msf[tr].sec, cdi.msf[tr].frame);
     END;
*)

     (* d.PrintF ("CalcDisc(cdi) = "); cddb.CalcDiscID(cdi); d.PrintF ("%08lx\n", cdi.discID); *)

     d.PrintF ("LoadKnownCD(0x00129C13)\n");
     IF ~cddb.LoadKnownCD (000129C13H, kCD) THEN d.PrintF ("  Disc (0x%lx) is unknown!\n", 000129C13H) 
     ELSE
        d.PrintF ("  Disc (0x%lx) is known!\n", 000129C13H); 
        d.PrintF ("  CD: length %02ld:%02ld, categ '%s', %ld Tracks, Title '%s'\n", kCD.length DIV 60, kCD.length MOD 60, y.ADR(kCD.categ), kCD.numTracks, y.ADR(kCD.title));

     END;

     d.PrintF ("LoadKnownCD(0x%lx)\n", cdi.discID);

     IF ~cddb.LoadKnownCD (cdi.discID, kCD) THEN
        d.PrintF ("  Disc (0x%lx) is unknown!\n", cdi.discID) 
     ELSE
        d.PrintF ("  Disc (0x%lx) is known!\n", cdi.discID); 
        d.PrintF ("  CD: length %02ld:%02ld, categ '%s', %ld Tracks, Title '%s'\n", kCD.length DIV 60, kCD.length MOD 60, y.ADR(kCD.categ), kCD.numTracks, y.ADR(kCD.title));
     END;
 

     d.PrintF ("cdi: tracks = %lD, time = %02ld:%02ld, discid = 0%lxH\n", cdi.tracks, cdi.time DIV 60, cdi.time MOD 60, cdi.discID);
(*   
     FOR tr := 0 TO cdi.tracks-1 DO
        d.PrintF ("%02ld: %02ld:%02ld.%03ld\n", tr+1, cdi.msf[tr].min, cdi.msf[tr].sec, cdi.msf[tr].frame);
     END;
*)
     FOR tr := 0 TO cdi.tracks-1 DO NEW(tTitles[tr]) END;

     NEW(CDDBStatusHook); u.InitHook (CDDBStatusHook, y.VAL(u.HookFunc, CDDBStatusFunc));

     err := cddb.Get (y.ADR(cdi),
        cddb.aDiscID, y.ADR(discID),
        cddb.aCateg,  y.ADR(categ),
        cddb.aArtist, y.ADR(artist),
        cddb.aDTitle, y.ADR(dTitle),
        cddb.aTTitles,y.ADR(tTitles),
        cddb.aStatusHook, CDDBStatusHook,
        cddb.aForceOnline,e.false,
        0);

     FOR tr := 0 TO cddb.errCOUNT-1 DO
        (* d.PrintF (""); *)
        ErrStr := cddb.ErrorStr (tr); d.PrintF ("Test ErrorStr(%ld) = '%s'\n", tr, ErrStr);
     END;

     (* ErrorStr (5, ErrStr); d.PrintF ("Test ErrorStr(5) = '%s'\n", ErrStr); *)
     IF err = cddb.errNoError THEN
        d.PrintF ("Current disc is %s/%s. Category is '%s'\n", y.ADR(artist), y.ADR(dTitle), y.ADR(categ));
        FOR tr := 0 TO cdi.tracks-1 DO
           min := cdi.msf[tr+1].min; sec := cdi.msf[tr+1].sec; frame := cdi.msf[tr+1].frame;
           min2:= cdi.msf[tr  ].min; sec2:= cdi.msf[tr  ].sec; frame2:= cdi.msf[tr  ].frame;
           secs := ((min*60*75 + sec*75 + frame) - (min2*60*75 + sec2*75 + frame2)) DIV 75;
           d.PrintF ("%02ld: %02ld:%02ld %s\n", tr+1, secs DIV 60, secs MOD 60, tTitles[tr]);
        END;
     ELSE
        ErrStr := cddb.ErrorStr(err); d.PrintF ("GetCDDB() err = %ld, %s\n", err, ErrStr);
     END;
     
CLOSE
     DISPOSE (CDDBStatusHook);
     IF scsi # NIL THEN
        bi.FreeSCSIUnit (scsi); scsi := NIL
     END;
    
     IF oldCD # NIL THEN oldCD := d.CurrentDir (oldCD); END;
     IF lock # NIL THEN d.UnLock(lock) END;
END GetCDDB.
